using System;
using Microsoft.Xna.Framework;

namespace SampleGame
{
    /// <summary>
    /// Rg[[NX
    /// </summary>
    public class Controller
    {
        #region Rg[
        // @^Cړn
        public static uint LEFT_UP              = 0x00000001;
	    public static uint LEFT_DOWN            = 0x00000002;
	    public static uint LEFT_LEFT            = 0x00000004;
	    public static uint LEFT_RIGHT           = 0x00000008;
        public static uint LEFT_DIRECT_ON       = (LEFT_UP | LEFT_DOWN | LEFT_LEFT | LEFT_RIGHT);

        // Jړn
        public static uint RIGHT_UP             = 0x00000010;
        public static uint RIGHT_DOWN           = 0x00000020;
        public static uint RIGHT_LEFT           = 0x00000040;
        public static uint RIGHT_RIGHT          = 0x00000080;
        public static uint RIGHT_DIRECT_ON      = (RIGHT_UP | RIGHT_DOWN | RIGHT_LEFT | RIGHT_RIGHT);

        // U{^
        public static uint BUTTON_ATTACK1       = 0x00000100;
        public static uint BUTTON_ATTACK2       = 0x00000200;
        // X^[g{^
        public static uint START                = 0x00004000;
        // ZNg{^
        public static uint SELECT               = 0x00008000;
        #endregion

        // L[
	    public uint m_keyStatus      = 0x00000000;
        // pbh̉
        public Vector2 m_padLeftStatus = new Vector2();
        public Vector2 m_padRightStatus = new Vector2();

        /// <summary>Rs[܂</summary>
        /// <param name="controller">Rg[[</param>
        public void Copy(Controller controller)
        {
            // L[ƃXeBbN̏Rs[܂
            m_keyStatus = controller.m_keyStatus;
            m_padLeftStatus = controller.m_padLeftStatus;
            m_padRightStatus = controller.m_padRightStatus;
        }

        /// <summary>Zbgs܂</summary>
        public void Reset()
        {
            m_keyStatus = 0;
            m_padLeftStatus = new Vector2(0, 0);
            m_padRightStatus = new Vector2(0, 0);
        }
    }
}
