using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SampleGame
{
    /// <summary>
    /// VXeǗNX
    /// VXeB̏ȂǂǗ܂
    /// </summary>
    public static class Global
    {
        // Q[CX^X
        public static SampleGame m_game = null;
        // Rg[[
        public static Controller m_controller = new Controller();
        // ͊Ǘ
        public static InputManager m_inputManager = new InputManager();
        // ^XNǗ
        public static TaskManager m_taskManager = new TaskManager();
        // \XN[TCY(ɃXvCg̃XP[OɎgp)
        public static Vector2 m_screenSize = new Vector2();
        // ƂȂXN[TCY(ɃXvCg̃XP[OɎgp)
        public static Vector2 m_screenNormalSize = new Vector2(800, 600);
        // Ǘ
        public static SoundManager m_soundManager = new SoundManager();

        /// <summary>s</summary>
        /// <param name="game">Q[CX^X</param>
        /// <returns>
        /// ʃR[h
        /// 1		I
        /// 1ȊO	G[
        /// </returns>
        public static int Initialize(SampleGame game)
        {
            // Q[CX^XA^b`
            m_game = game;

            // fc[܂
            if(ModelTool.Initialize(game.content) == false)
            {
                return -1;
            }

            // XvCgc[܂
            if (SpriteTool.Initialize(game.content, game.graphics.GraphicsDevice) == false)
            {
                return -2;
            }

            // ƂȂXN[TCY(ɃXvCg̃XP[OɎgp)
            m_screenSize.X = game.graphics.PreferredBackBufferWidth;
            m_screenSize.Y = game.graphics.PreferredBackBufferHeight;

            // `Ǘ̍Wݒ肵܂i͓Kj
            DrawManager.SetCoodinate(game.Window.ClientBounds);

            // Ǘ
            m_soundManager.Initialize();

            return 1;
        }

        /// <summary>Q[̉Zs܂</summary>
        /// <returns>
        /// 1   Q[s
        /// 0   Q[I
        /// </returns>
        public static int Execute()
        {
            int result = 1;

            // ͏s܂
            m_inputManager.Execute();

            // o^Ă^XNs܂
            m_taskManager.Execute();

            // Ǘ̎s
            m_soundManager.Execute();

            return result;
        }
    }
}
