using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace SampleGame
{
    /// <summary>fLN^[</summary>
    public class ModelCharacterTask : CharacterTask
    {
        // ݂̃f
        public Model m_model = null;
        // LN^̍W
        public Vector3 m_centerPosition = new Vector3();
        // LN^̏Փ˗̈
        public BoundingBox m_collisionBox = new BoundingBox();
        // LN^̉]
        public Vector3 m_rotate = new Vector3();
        // LN^[̃XP[
        public bool m_scaleOn = true;
        public Vector3 m_scale = new Vector3(1, 1, 1);
        // LN^[̓
        public bool m_alphaOn = false;
        public float m_alpha = 1;

        /// <summary>RXgN^</summary>
        public ModelCharacterTask()
            : base(ID.DEFAULT, ATTRIBUTE_CHARACTER_MODEL, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        public ModelCharacterTask(ID taskID)
            : base(taskID, ATTRIBUTE_CHARACTER_MODEL, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        /// <param name="taskAttribute">^XNiTask.ATTRIBUTE_* ܂͔CӁj</param>
        public ModelCharacterTask(ID taskID, uint taskAttribute)
            : base(taskID, taskAttribute | ATTRIBUTE_CHARACTER_MODEL, 0)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN ID (Task.ID.*)</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public ModelCharacterTask(ID taskID, int taskNo)
            : base(taskID, taskNo)
        {
        }

        /// <summary>RXgN^</summary>
        /// <param name="taskID">^XN IDiTask.ID ܂͔CӁj</param>
        /// <param name="taskAttribute">^XNiTask.ATTRIBUTE_* ܂͔CӁj</param>
        /// <param name="taskNo">^XNԍ(Cӂ̔ԍ)</param>
        public ModelCharacterTask(ID taskID, uint taskAttribute, int taskNo)
            : base(taskID, taskAttribute | ATTRIBUTE_CHARACTER_MODEL, taskNo)
        {
        }

        /// <summary>fǂݍ݂܂</summary>
        public virtual void LoadModel()
        {
            // hŔCӂɎgp܂
        }

        /// <summary>OŊǗĂ郂f擾܂</summary>
        /// <returns>f</returns>
        /// <remarks>̊֐͔hŐÓIɎfǗs܂</remarks>
        public virtual Model GetModel()
        {
            return m_model;
        }

        /// <summary>Wݒ肵܂</summary>
        /// <param name="center">IuWFNg̒SW</param>
        public virtual void SetCoordinate(Vector3 center)
        {
            m_centerPosition = center;
        }

        /// <summary>Wݒ肵܂</summary>
        /// <param name="center">IuWFNg̒SW</param>
        /// <param name="collisionSize">S_ƂՓ˗̈</param>
        public virtual void SetCoordinate(Vector3 center, Vector3 collisionSize)
        {
            m_centerPosition = center;
            SetCollisionBox(collisionSize);
        }

        /// <summary>qbg`ݒ肵܂</summary>
        /// <param name="size">S_ 0 ̍L</param>
        public virtual void SetCollisionBox(float size)
        {
            m_collisionBox = new BoundingBox(
                new Vector3(-size, -size, -size),
                new Vector3(size, size, size));
        }

        /// <summary>qbg`ݒ肵܂</summary>
        /// <param name="center">S_</param>
        /// <param name="size">S_ 0 ̍L</param>
        public virtual void SetCollisionBox(Vector3 size)
        {
            m_collisionBox = new BoundingBox(
                new Vector3(-size.X, -size.Y, -size.Z),
                new Vector3(size.X, size.Y, size.Z));
        }

        /// <summary>LN^[Ŝ̃qbg蔼a擾܂</summary>
        /// <returns>a</returns>
        public virtual float GetHitRadius()
        {
            // ̏͏ǂqbg̈悪ł猟܂
            return (m_collisionBox.Max.Z - m_collisionBox.Min.Z) / 2;
        }

        /// <summary>`Cxg</summary>
        public override void Draw()
        {
            // fꍇ͕`ł܂
            if (m_model == null)
            {
                return;
            }

            // f`悵܂
            DrawManager.DrawModel(
                m_model,
                m_centerPosition, m_rotate,
                m_scaleOn, m_scale, m_alphaOn, m_alpha);
        }
    }
}
