using Microsoft.Xna.Framework.Audio;

namespace SampleGame
{
    /// <summary></summary>
    public enum SoundType
    {
        UNDEFINE = 0,
        SE,
        BGM,
    }

    /// <summary>t@C(͏󋵂ɂ)</summary>
    public enum SoundDataFormatType
    {
	    UNDEFINE = 0,
	    WAV,
	    MIDI,
	    MP3,
    }

    /// <summary></summary>
    public class SoundItem
    {
        // ID
        public SoundID m_id = 0;
        //  (enum SoundType)
        public SoundType m_type = SoundType.UNDEFINE;
        // f[^tH[}bg (enum SoundDataFormatType)
        public SoundDataFormatType m_dataFormatType = SoundDataFormatType.WAV;
        // t@C
        public string m_fileName;
        // [v (0Ŗ)
        public int m_loopCount = 1;
        // Đ
        public int m_playCount = 0;
        // ĐJnV[Nʒu
        public long m_startSeekPoint = 0;
        // ĐIʒu (0 ōŌ܂)
        public long m_endSeekPoint = 0;
        // Sound Cue 
        public Cue m_cue;
    }
}
